﻿using Syncfusion.Windows.Forms.Grid.Grouping;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.GridHelperClasses;
using System.Drawing.Printing;
using System.Collections;

namespace CellGrid
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.StartPosition = FormStartPosition.CenterScreen;
            DataCollection data = new DataCollection();
            Random rand = new Random();
            int r = rand.Next(100);
            for (int i = 0; i < 85; i++)
            {
                data.Add(new Data(i, "Category" + r.ToString(), "Desc" + r.ToString(), r.ToString() + "Data"));
                r = rand.Next(100);
            }

            gridGroupingControl1.DataSource = data;
            this.gridGroupingControl1.AllowProportionalColumnSizing = true;
            this.gridGroupingControl1.TopLevelGroupOptions.ShowCaption = false;
            this.gridGroupingControl1.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Metro;
        }

        private void print_Click(object sender, EventArgs e)
        {
            GroupingGridPrintDocumentAdv printDocument = new GroupingGridPrintDocumentAdv(this.gridGroupingControl1);
            printDocument.HeaderPrintStyleInfo.Text = "Syncfusion Software Private Ltd";
            printDocument.HeaderPrintStyleInfo.Font.Bold = true;
            printDocument.HeaderPrintStyleInfo.Font.Size = 20;
            printDocument.HeaderPrintStyleInfo.TextColor = Color.Orange;
            printDocument.HeaderPrintStyleInfo.HorizontalAlignment = GridHorizontalAlignment.Center;
            printDocument.HeaderHeight = 30;
            //Event Subscription.
            printDocument.PrintPage += new PrintPageEventHandler(printDocument_PrintPage);
            printDocument.DrawGridPrintHeader += new GridPrintDocumentAdv.DrawGridHeaderFooterEventHandler(printDocument_DrawGridPrintHeader);
            PrintPreviewDialog previewDialog = new PrintPreviewDialog();
            previewDialog.Document = printDocument;
            printDocument.DefaultPageSettings.Landscape = false;
            printDocument.DefaultPageSettings.Margins = new System.Drawing.Printing.Margins(0, 0, 0, 0);
            previewDialog.ShowDialog();
        }


        bool firstPagePrinted = true; int pageIndex = 1; int NoOfRecordsToAdd = 2;
        void printDocument_PrintPage(object sender, PrintPageEventArgs e)
        {
            if (firstPagePrinted)
            {
                e.PageSettings.Margins = new Margins(0, 0, 0, 0);
                if (pageIndex + 1 < this.gridGroupingControl1.TableControl.PrintInfo.m_awPageFirstRow.Count)
                {
                    int nextFirstRowValue = (int)this.gridGroupingControl1.TableControl.PrintInfo.m_awPageFirstRow[pageIndex + 1];
                    int lastRowValue = (int)this.gridGroupingControl1.TableControl.PrintInfo.m_awPageFirstRow[this.gridGroupingControl1.TableControl.PrintInfo.m_awPageFirstRow.Count - 1];
                    if (nextFirstRowValue + (pageIndex * NoOfRecordsToAdd) < lastRowValue)
                        this.gridGroupingControl1.TableControl.PrintInfo.m_awPageFirstRow[pageIndex + 1] = nextFirstRowValue + (pageIndex * NoOfRecordsToAdd);
                    else
                    {
                        this.gridGroupingControl1.TableControl.PrintInfo.m_awPageFirstRow[pageIndex + 1] = (int)this.gridGroupingControl1.TableControl.PrintInfo.m_awPageFirstRow[this.gridGroupingControl1.TableControl.PrintInfo.m_awPageFirstRow.Count - 1];
                        for (int i = pageIndex + 2; i < this.gridGroupingControl1.TableControl.PrintInfo.m_awPageFirstRow.Count; i++)
                        {
                            this.gridGroupingControl1.TableControl.PrintInfo.m_awPageFirstRow.RemoveAt(i);
                        }
                    }
                }
                pageIndex++;
            }
        }
        
        void printDocument_DrawGridPrintHeader(object sender, GridPrintHeaderFooterTemplateArgs e)
        {
            if (e.PageNumber == 1)
                firstPagePrinted = true;
            else
            {
                //To avoid Headers in pages other than first page.
                e.Cancel = true;
            }           
        }
    }
}
